package version9_2.display;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import version9_2.Interface.InteractionList;
import version9_2.platform.Agent;

/**
 * Display space memory data
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class SpacePanel extends EnvPanel implements MouseListener{

	private static final long serialVersionUID = 1L;
	
	private int clic_x=0;
	private int clic_y=0;
	
	public SpacePanel(Agent a){
		super(a);
		addMouseListener(this);
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1350, 1000);
		
		// learning switch
		if (agent.decision.learning()) g.setColor(Color.red);
		else g.setColor(Color.black);
		g.fillRect(305, 330, 10, 10);
		g.setColor(Color.black);
		g.drawString("enable learning mechanism", 320, 340);
		
		// draw space map
		for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2*2;j++){
				for (int m=0;m<9;m++){
					g.setColor(new Color(agent.spaceMemory.spaceMap[i][j][m][2],
							 			 agent.spaceMemory.spaceMap[i][j][m][0],
							 			 agent.spaceMemory.spaceMap[i][j][m][1]));
					g.fillRect(700+i*2 +205*( (int)(m/3)), 200-j*2+210*(m%3), 2, 2);
				}
			}
		}
		
		
		// predicted environments
		/*for (int m=0;m<agent.interactionList.nbInteraction();m++){
			for (int i=0;i<InteractionList.size1;i++){
				for (int j=0;j<InteractionList.size2*2;j++){
					g.setColor(new Color(agent.spaceMemory.getPredictionMap(m,i,j,0,2),
							 			 agent.spaceMemory.getPredictionMap(m,i,j,0,0),
							 			 agent.spaceMemory.getPredictionMap(m,i,j,0,1)));
					
					g.fillRect(520+i*2+205*((int)(m/2)), 200-j*2+205*(m%2), 2, 2);
				}
			}
		}*/
		
		///////////////////////////////////////////////////////////////////////////
		// draw perceived environment
		/*for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2;j++){
				g.setColor(new Color(agent.spaceMemory.enactedEnsembles[0][i*InteractionList.size2*3+j*3+2],
									 agent.spaceMemory.enactedEnsembles[0][i*InteractionList.size2*3+j*3  ],
									 agent.spaceMemory.enactedEnsembles[0][i*InteractionList.size2*3+j*3+1]));
				g.fillRect(5+i*2 , 100-j*2, 2, 2);
			}
		}
		for (int i=0;i<8;i++){
			g.setColor(new Color(1-(agent.spaceMemory.enactedEnsembles[0][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f),
									agent.spaceMemory.enactedEnsembles[0][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f,0));
			g.fillRect(5+12*i,5+ 100, 10, 10);
		}
		
		for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2;j++){
				g.setColor(new Color(agent.spaceMemory.enactedEnsembles[1][i*InteractionList.size2*3+j*3+2],
									 agent.spaceMemory.enactedEnsembles[1][i*InteractionList.size2*3+j*3  ],
									 agent.spaceMemory.enactedEnsembles[1][i*InteractionList.size2*3+j*3+1]));
				g.fillRect(5+i*2 ,220-j*2, 2, 2);
			}
		}
		for (int i=0;i<8;i++){
			g.setColor(new Color(1-(agent.spaceMemory.enactedEnsembles[1][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f),
									agent.spaceMemory.enactedEnsembles[1][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f,0));
			g.fillRect(5+12*i,5+ 220,10, 10);
		}
		
		
		/*for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2;j++){
				g.setColor(new Color(agent.spaceMemory.enactedEnsembleCartesian[i][j][2],
						 			 agent.spaceMemory.enactedEnsembleCartesian[i][j][0],
						 			 agent.spaceMemory.enactedEnsembleCartesian[i][j][1]));
				g.fillRect(5+i*2 ,340-j*2, 2, 2);
			}
		}*/
		
		
		for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2;j++){
				for (int m=0;m<9;m++){
					g.setColor(new Color(agent.spaceMemory.enactedEnsemblesM[0][m][i*InteractionList.size2*3+j*3+2],
										 agent.spaceMemory.enactedEnsemblesM[0][m][i*InteractionList.size2*3+j*3  ],
										 agent.spaceMemory.enactedEnsemblesM[0][m][i*InteractionList.size2*3+j*3+1]));
					g.fillRect(10+i*2 +210*( (int)(m/3) ),  100-j*2 + 110*(m%3), 2, 2);
				}
			}
		}
		for (int i=0;i<8;i++){
			g.setColor(new Color(1-(agent.spaceMemory.enactedEnsemblesM[0][0][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f),
									agent.spaceMemory.enactedEnsemblesM[0][0][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f,0));
			g.fillRect(10+12*i,5+ 320, 10, 10);
		}
		
		// draw previous environment
		/*for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2;j++){
				g.setColor(new Color(agent.spaceMemory.enactedEnsemblesM[1][0][i*InteractionList.size2*3+j*3+2],
									 agent.spaceMemory.enactedEnsemblesM[1][0][i*InteractionList.size2*3+j*3  ],
									 agent.spaceMemory.enactedEnsemblesM[1][0][i*InteractionList.size2*3+j*3+1]));
				g.fillRect(10+i*2,225-j*2, 2, 2);
			}
		}
		for (int i=0;i<8;i++){
			g.setColor(new Color(1-(agent.spaceMemory.enactedEnsemblesM[1][0][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f),
									agent.spaceMemory.enactedEnsemblesM[1][0][InteractionList.size1*InteractionList.size2*3+i]/2+0.5f,0));
			g.fillRect(10+12*i,5+ 225, 10, 10);
		}*/
		
		
		
		g.setColor(Color.black);
		int index=0;
		for (int i=0;i<agent.interactionList.nbInteraction();i++){
			String display=agent.spaceMemory.getInteraction(i).getName(0)+" : "+agent.spaceMemory.getInteraction(i).getValence()+" ; "
			               +( agent.spaceMemory.getInteraction(i).getValence()
			                 +agent.spaceMemory.getAdditional(i));
			if (agent.spaceMemory.getInteraction(i).getPrediction()>=0){
				display+=" , (";
				for (int j=0;j<agent.spaceMemory.getInteraction(i).predictions1.size();j++){
					if (i!=j){
						display+= agent.interactionList.getInteraction(j).valence()+" X ("
						         +agent.spaceMemory.getInteraction(j).predictions2.get(i)+" - "
						          +agent.spaceMemory.getInteraction(j).predictions1.get(i)+ ") + ";
					}
				}
				display+=" ) ";
						
				g.drawString(display, 15, 700+15*(index));
				index++;
			}
		}/**/
		
		
		
		
		// counters
		for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2;j++){
				for (int m=0;m<9;m++){
					g.setColor(new Color(250-10*agent.spaceMemory.counters[2][m][i*InteractionList.size2*3+j*3+2],
										 250-10*agent.spaceMemory.counters[2][m][i*InteractionList.size2*3+j*3  ],
										 250-10*agent.spaceMemory.counters[2][m][i*InteractionList.size2*3+j*3+1]));
					g.fillRect(10+i*2 +210*( (int)(m/3) ),  350+100-j*2 + 110*(m%3), 2, 2);
				}
			}
		}
		for (int i=0;i<8;i++){
			g.setColor(new Color(250-10*agent.spaceMemory.counters[2][0][InteractionList.size1*InteractionList.size2*3+i],
								 250-10*agent.spaceMemory.counters[2][0][InteractionList.size1*InteractionList.size2*3+i],
								 250-10*agent.spaceMemory.counters[2][0][InteractionList.size1*InteractionList.size2*3+i] ));
			g.fillRect(10+12*i,355+ 320, 10, 10);
		}
		
		
		// draw predicted map
		for (int i=0;i<InteractionList.size1;i++){
			for (int j=0;j<InteractionList.size2*2;j++){
				for (int m=0;m<9;m++){
					g.setColor(new Color(agent.spaceMemory.predictionMap.get(3)[i][j][m][2],
							 			 agent.spaceMemory.predictionMap.get(3)[i][j][m][0],
							 			 agent.spaceMemory.predictionMap.get(3)[i][j][m][1]));
					g.fillRect(1500+i*2 +205*( (int)(m/3)), 200-j*2+210*(m%3), 2, 2);
				}
			}
		}
		
		
		// draw predicted environment
		
		
		
	}
	
	
	///////////////////////////////////////////////////////////////////////////
	public Color getColor(float[][] map, int t, int i){
		return new Color( (Math.min(1, Math.max(-1, map[t][i  ]))+1)/2,
						  (Math.min(1, Math.max(-1, map[t][i+1]))+1)/2,
						  (Math.min(1, Math.max(-1, map[t][i+2]))+1)/2);
	}
	public Color getColor2(float[][] map, int t, int i){
		return new Color( (Math.min(1, Math.max(-1, map[t][i  ]))+1)/2,
						  (Math.min(1, Math.max(-1, map[t][i+1]))+1)/2,
						  0);
	}
	
	public Color getColor(float[] map, int i){
		return new Color( (Math.min(1, Math.max(-1, map[i  ]))+1)/2,
						  (Math.min(1, Math.max(-1, map[i+1]))+1)/2,
						  (Math.min(1, Math.max(-1, map[i+2]))+1)/2);
	}
	public Color getColor2(float[] map, int i){
		return new Color( (Math.min(1, Math.max(-1, map[i  ]))+1)/2,
						  (Math.min(1, Math.max(-1, map[i+1]))+1)/2,
						  0);
	}
	
	///////////////////////////////////////////////////////////////////////////
	public void mouseClicked(MouseEvent e) {

		clic_x=e.getX();
		clic_y=e.getY();

		if (clic_x>=(305) && clic_x<=(315) && clic_y>=330 && clic_y<=340) 
			agent.decision.setLearning();
	}

	@Override
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	
}
