package version9_2_2_1.agnosticMemory;

import version9_2_2_1.Interface.InteractionList;
import version9_2_2_1.Interface.PrimitiveInteraction;
import version9_2_2_1.platform.Agent;

/**
 * Decision system.
 * This class selects the intended interactions
 * @author simon
 */
public class Decision {

	private Agent agent;
	
	private PrimitiveInteraction intention;
	
	//private int lock=0;
	//private int lockId=-1;
	
	private Thread[] t_utility;
	private float[] utilities;
	
	///////////////////////////////////////////////////////////
	public Decision(Agent a){
		agent=a;
		
		t_utility=new Thread[7];
		utilities=new float[7];
	}
	
	/**
	 * decision of the next interaction
	 * @return the intended interaction
	 */
	public PrimitiveInteraction decision(){
		System.out.println();System.out.println();
		
		//int imin=-1;
		//float min=10000;

		// a candidate interaction must be valid and not predicted as a failure with high certitude,
		// and must be a primary interaction or being predicted with a sufficient certitude to avoid unpredictable interactions
		/*for (int i=0;i<InteractionList.length-1;i++){
			if (agent.signatureList.isValid(i)/* && agent.signatureList.get(i).prediction>-0.9*/
			/* && (i>=InteractionList.nbDF || Math.abs(agent.signatureList.get(i).getPrediction())>0.2)){
				
				//System.out.print("**** "+i+" ; "+agent.signatureList.get(i).getPrediction());
				if ((lockId!=i || lock<5) && Math.abs(agent.signatureList.get(i).getPrediction())<min){
					imin=i;
					min=Math.abs(agent.signatureList.get(i).getPrediction());
				}
			}
		}
		
		System.out.println("Select interaction "+imin+" : "+agent.signatureList.get(imin).interaction().getName()+" ; "+agent.signatureList.get(imin).getPrediction()+" ; "+lockId+": "+lock);
		intention=agent.signatureList.get(imin).interaction();

		if (imin==lockId) lock++;
		else{
			lockId=imin;
			lock=0;
		}*/
		
		float max=-1;
		int imax=-1;
		
		/*for (int i=0;i<7;i++){
			
			if (agent.signatureList.get(InteractionList.nbDF+i).getPrediction()>-0.2){
				float utility=getUtility(i);
				System.out.println(" +++ "+i+ " ; "+utility + " ; "+agent.signatureList.get(InteractionList.nbDF+i).getPrediction());
				if (utility>max){
					max=utility;
					imax=i;
				}
			}
		}*/
		
		for (short i=0;i<7;i++) t_utility[i]=new UtilityThread(i);
		for (short i=0;i<7;i++) t_utility[i].start();
		try {
			for (short i=0;i<7;i++) t_utility[i].join();
		} catch (InterruptedException e){e.printStackTrace();}
		
		for (short i=0;i<7;i++){
			System.out.println(" +++ "+i+ " ; "+utilities[i] + " ; "+agent.signatureList.get(InteractionList.nbDF+i).getPrediction());
			if (utilities[i]>max && utilities[i]!=-1){
				max=utilities[i];
				imax=i;
			}
		}
		
		System.out.println("Select interaction "+imax+" : "+agent.signatureList.get(InteractionList.nbDF+imax).interaction().getName()+", utility : "+max);
		intention=agent.signatureList.get(InteractionList.nbDF+imax).interaction();
		
		return intention;
	}
	
	
	private void getUtility(int id){
		float sum=0;
		float sum1=0;
		
		if (agent.signatureList.get(InteractionList.nbDF+id).getPrediction()>-0.3){
			
			// move forward
			if (id<1){
				sum1=0;
				for (int j=0;j<InteractionList.length-1;j++){
					if (agent.environmentContext.enactedEnsembles[0][j]==1) sum1+= agent.environmentContext.counter[id][j];
				}
				sum+=sum1* InteractionList.nbType;
				for (int i=id*InteractionList.nbType;i<(id+1)*InteractionList.nbType;i++){
					//sum1=0;
					//if (Math.abs(agent.signatureList.get(i).getPrediction())>0.2){
						/*for (int j=0;j<InteractionList.length-1;j++){
							if (agent.environmentContext.enactedEnsembles[0][j]==1) sum1+= agent.environmentContext.counter[id][j] ;
						}*/
						sum+= (1 - Math.abs(agent.signatureList.get(i).getPrediction()));
					//}
				}
				sum1=0;
				for (int j=0;j<InteractionList.length-1;j++){
					if (agent.environmentContext.enactedEnsembles[0][j]==1) sum+= agent.environmentContext.counter[id][j]  ;
				}
				sum+=sum1 + (1 - Math.abs(agent.signatureList.get(InteractionList.nbDF+id).getPrediction()));
			}
			
			// bump
			if (id==1){
				sum1=0;
				for (int j=0;j<InteractionList.length-1;j++){
					if (agent.environmentContext.enactedEnsembles[0][j]==1) sum1+= agent.environmentContext.counter[id][j] ;
				}
				sum+=sum1 + (1 - Math.abs(agent.signatureList.get(InteractionList.nbDF+1).getPrediction()));
			}
			
			// other interactions
			if (id>1){
				sum1=0;
				for (int j=0;j<InteractionList.length-1;j++){
					if (agent.environmentContext.enactedEnsembles[0][j]==1) sum1+= agent.environmentContext.counter[id][j] ;
				}
				sum+=sum1* InteractionList.nbType;
				for (int i=(id-1)*InteractionList.nbType;i<id*InteractionList.nbType;i++){
					//sum1=0;
					//if (Math.abs(agent.signatureList.get(i).getPrediction())>0.2){
						/*for (int j=0;j<InteractionList.length-1;j++){
							if (agent.environmentContext.enactedEnsembles[0][j]==1) sum1+= agent.environmentContext.counter[id][j] ;
						}*/
						sum+= (1 - Math.abs(agent.signatureList.get(i).getPrediction()));
					//}
				}
				sum1=0;
				for (int j=0;j<InteractionList.length-1;j++){
					if (agent.environmentContext.enactedEnsembles[0][j]==1) sum1+= agent.environmentContext.counter[id][j] ;
				}
				sum+=sum1 + (1 - Math.abs(agent.signatureList.get(InteractionList.nbDF+id).getPrediction()));
			}
			
			utilities[id]=sum;
		}
		else utilities[id]=-1;
	}
	
	

	/**
	 * Get the last intended interaction
	 * @return the last selected intended interaction
	 */
	public PrimitiveInteraction getIntention(){
		return intention;
	}
	
	
	//////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////
	
	private class UtilityThread extends Thread {
		
		private short id;
		
		public UtilityThread(short i){
			super();
			id=i;
		}
		public void run(){
			getUtility(id);
		}
	}
	
}
