package version9_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import version9_2_2_1.platform.Agent;
import version9_2_2_1.Interface.InteractionList;

/**
 * Frame to display signatures of interactions
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class ContextPanel extends EnvPanel implements MouseListener{

	private static final long serialVersionUID = 1L;

	private short clic_x=0;
	private short clic_y=0;
	
	private byte pixel=4;
	
	private byte selected_color=0;
	
	private byte counterSelector=0;
	
	private int size1=InteractionList.size1;
	private int size2=InteractionList.size2;

	public ContextPanel(Agent a){
		super(a);
		addMouseListener(this);
	}
	
	public void setAgent(Agent a){
		agent=a;
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1300, 900);
		
		//////////////////////////////////////////////////////////////
		// draw interactional context

		// dynamic features
		for (byte l=0;l<9;l++){
			for (byte n=0;n<6;n++){
				for (short i=0;i<size1;i++){
					for (short j=0;j<size2;j++){
						if (l==4){
							g.setColor(new Color(agent.environmentContext.enactedEnsembles[0][i*size2+j+n*size1*size2 +10*InteractionList.nbType ],
												 agent.environmentContext.enactedEnsembles[0][i*size2+j+n*size1*size2 + 9*InteractionList.nbType ],
												 agent.environmentContext.enactedEnsembles[0][i*size2+j+n*size1*size2 + 4*InteractionList.nbType ] ));
						}
						else{
							g.setColor(new Color(0,
									 			 0,
									 			 agent.environmentContext.enactedEnsembles[0][i*size2+j+n*size1*size2 + l*InteractionList.nbType ] ));
						}
						
						g.fillRect(10+i*pixel+34*pixel*l, (17-j)*pixel + n*17*pixel, pixel, pixel);
					}
				}
				
			}
		}
		
		// primitive interactions
		for (byte i=0;i<8;i++){
			g.setColor(new Color(1-(agent.environmentContext.enactedEnsembles[0][InteractionList.nbDF+i]/2+0.5f),
								    agent.environmentContext.enactedEnsembles[0][InteractionList.nbDF+i]/2+0.5f,0));

			g.fillRect(20+i*20, 430, 10, 10);
		}
		
		// color selector
		g.setColor(Color.green);
		g.fillRect(200, 430, 10, 10);
		g.setColor(Color.blue);
		g.fillRect(220, 430, 10, 10);
		g.setColor(Color.red);
		g.fillRect(240, 430, 10, 10);
		
		
		
		///////////////////////////////////////////////////////////////////////////////
		// draw counters
		
		// draw selector
		for (byte i=0;i<7;i++){
			if (counterSelector==i) g.setColor(Color.red);
			else g.setColor(Color.black);
			
			g.fillRect(20,500+i*20,10,10);
		}

		// dynamic features
		for (byte l=0;l<9;l++){
			for (byte n=0;n<6;n++){
				for (short i=0;i<size1;i++){
					for (short j=0;j<size2;j++){
						if (l==4){
							g.setColor(new Color(250-agent.environmentContext.counter[counterSelector][i*size2+j+n*size1*size2 +10*InteractionList.nbType ]*10,
												 250-agent.environmentContext.counter[counterSelector][i*size2+j+n*size1*size2 + 9*InteractionList.nbType ]*10,
												 250-agent.environmentContext.counter[counterSelector][i*size2+j+n*size1*size2 + 4*InteractionList.nbType ]*10 ));
						}
						else{
							g.setColor(new Color(0,
									 			 0,
									 			 250-agent.environmentContext.counter[counterSelector][i*size2+j+n*size1*size2 + l*InteractionList.nbType ]*10 ));
						}
						
						g.fillRect(40+i*pixel+34*pixel*l, 500+(17-j)*pixel + n*17*pixel, pixel, pixel);
					}
				}
				
			}
		}
		
		// primitive interactions
		for (byte i=0;i<8;i++){
			g.setColor(new Color(250-agent.environmentContext.counter[counterSelector][InteractionList.nbDF+i]*10,
							     250-agent.environmentContext.counter[counterSelector][InteractionList.nbDF+i]*10,
							     250-agent.environmentContext.counter[counterSelector][InteractionList.nbDF+i]*10));

			g.fillRect(50+i*20, 930, 10, 10);
		}
		
		
		///////////////////////////////////////////////////////////////////////////////
		// draw predicted context
		
		// dynamic features
		/*for (byte l=0;l<9;l++){
			for (byte n=0;n<6;n++){
				for (short i=0;i<size1;i++){
					for (short j=0;j<size2;j++){
						if (l==4){
							g.setColor(new Color(Math.max(0, Math.min(1, agent.environmentContext.predictedContext[i*size2+j+n*size1*size2 +10*InteractionList.nbType ]/2+0.5f)),
												 Math.max(0, Math.min(1, agent.environmentContext.predictedContext[i*size2+j+n*size1*size2 + 9*InteractionList.nbType ]/2+0.5f)),
												 Math.max(0, Math.min(1, agent.environmentContext.predictedContext[i*size2+j+n*size1*size2 + 4*InteractionList.nbType ]/2+0.5f)) ));
						}
						else{
							g.setColor(new Color(0.5f,
									 			 0.5f,
									 			 Math.max(0, Math.min(1, agent.environmentContext.predictedContext[i*size2+j+n*size1*size2 + l*InteractionList.nbType ]/2+0.5f ))));
						}
						
						g.fillRect(40+i*pixel+34*pixel*l, 500+(17-j)*pixel + n*17*pixel, pixel, pixel);
					}
				}
				
			}
		}
		
		// primitive interactions
		for (byte i=0;i<8;i++){
			g.setColor(new Color(Math.max(0, Math.min(1, agent.environmentContext.predictedContext[InteractionList.nbDF+i]/2+0.5f)),
								 Math.max(0, Math.min(1, agent.environmentContext.predictedContext[InteractionList.nbDF+i]/2+0.5f)),
								 Math.max(0, Math.min(1, agent.environmentContext.predictedContext[InteractionList.nbDF+i]/2+0.5f))));

			g.fillRect(50+i*20, 930, 10, 10);
		}*/
	}
	
	
	///////////////////////////////////////////////////////////////////////////
	public void mouseClicked(MouseEvent e) {

		clic_x=(short) e.getX();
		clic_y=(short) e.getY();

		for (byte c=0;c<3;c++){
			if (clic_x>=200+20*c && clic_x<220+10*c && clic_y>=430 && clic_y<440)
				selected_color=c;
		}
		
		
		for (byte l=0;l<9;l++){
			for (byte n=0;n<6;n++){
				for (short i=0;i<size1;i++){
					for (short j=0;j<size2;j++){
						if (clic_x>=10+i*pixel+34*pixel*l     && clic_x<10+i*pixel+34*pixel*l+pixel
								 && clic_y>=(17-j)*pixel + n*17*pixel && clic_y<(17-j)*pixel + n*17*pixel+pixel){
							if (l==4){
								if (selected_color==0) agent.observer.setSelectedNode(i*size2 + j + n*size1*size2 + 9*InteractionList.nbType);
								if (selected_color==1) agent.observer.setSelectedNode(i*size2 + j + n*size1*size2 + 4*InteractionList.nbType);
								if (selected_color==2) agent.observer.setSelectedNode(i*size2 + j + n*size1*size2 +10*InteractionList.nbType);
							}
							else{
								agent.observer.setSelectedNode(i*size2 + j + n*size1*size2 + l*InteractionList.nbType);
							}
						}
					}
				}
				
			}
		}
		
		// primitive interactions
		for (byte i=0;i<7;i++){
			
			if (clic_x>=20+i*20 && clic_x<=30+i*20 && clic_y>=430 && clic_y<=440){
				agent.observer.setSelectedNode(InteractionList.nbDF+i);
			}
		}
		
		// counter selector
		for (byte i=0;i<7;i++){
			if (clic_x>=20 && clic_x<=30 && clic_y>=500+i*20 && clic_y<=510+i*20)
				counterSelector=i;
		}
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
