package version9_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;

import version9_2_2_1.platform.Agent;
import version9_2_2_1.Interface.InteractionList;
import version9_2_2_1.agnosticMemory.Signature;

/**
 * Frame to display signatures of interactions
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class SignaturePanel extends EnvPanel{

	private static final long serialVersionUID = 1L;
	
	private byte pixel=4;
	
	private int size1=InteractionList.size1;
	private int size2=InteractionList.size2;
	
	public SignaturePanel(Agent a){
		super(a);
	}
	
	public void setAgent(Agent a){
		agent=a;
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1300, 900);
		
		///////////////////////////////////////////////////////////////////////////////
		// draw signature
		if (agent.observer.getSelectedNode()!=-1){
			// dynamic features
			Signature sig=agent.signatureList.get(agent.observer.getSelectedNode());
			float max1=sig.maxPattern1;
			float max2=sig.maxPattern2;
			

			float norm=Math.max(500, max1);
			//float norm=0.1f;
			
			for (byte l=0;l<9;l++){
				for (byte n=0;n<6;n++){
					for (short i=0;i<size1;i++){
						for (short j=0;j<size2;j++){
							if (l==4){
								g.setColor(new Color(Math.min(1, Math.max(0, ( ((float)(sig.signature[i*size2+j+n*size1*size2 +10*InteractionList.nbType ])) /norm +1)/2 )),
													 Math.min(1, Math.max(0, ( ((float)(sig.signature[i*size2+j+n*size1*size2 + 9*InteractionList.nbType ])) /norm +1)/2 )),
													 Math.min(1, Math.max(0, ( ((float)(sig.signature[i*size2+j+n*size1*size2 + 4*InteractionList.nbType ])) /norm +1)/2 )) ));
							}
							else{
								g.setColor(new Color(0.5f,
										 			 0.5f,
										 			Math.min(1, Math.max(0, ( ((float)(sig.signature[i*size2+j+n*size1*size2 +l*InteractionList.nbType ])) /norm +1)/2 )) ));
							}
							g.fillRect(10+i*pixel+32*pixel*l, (17-j)*pixel + n*16*pixel, pixel, pixel);
						}
					}
				}
			}
			
			
			// primitive interactions
			norm=Math.max(1000, max2);
			for (byte i=0;i<8;i++){
				
				g.setColor(new Color(Math.min(1, Math.max(0, 1-( ((float)(sig.signature[InteractionList.nbDF+i])) /norm+1)/2 )),
									 Math.min(1, Math.max(0,   ( ((float)(sig.signature[InteractionList.nbDF+i])) /norm+1)/2 )),
									 0));

				g.fillRect(20+i*20, 410, 10, 10);
			}
			
			for (byte l=0;l<11;l++){
				for (byte n=0;n<6;n++){
					for (short i=0;i<size1;i++){
						for (short j=0;j<size2;j++){
							
							if (agent.observer.getSelectedNode()==i*size2+j+n*size1*size2 +l*InteractionList.nbType){
								int l2=l;
								if (l>8) l2=4;
								g.setColor(Color.red);
								g.drawRect(9+i*pixel+32*pixel*l2, (17-j)*pixel + n*16*pixel-1, pixel+1, pixel+1);
							}
						}
					}
				}
			}
		}
	}
}
