package version9_2_2_1.platform;

import java.util.ArrayList;

import version9_2_2_1.display.EnvFrame;

/**
 * A list of panel that display data about an agent
 * @author simon gay
 *
 */
public class Display {

	private ArrayList<EnvFrame> frameList;			// list of displayer
	
	public Display(){
		frameList=new ArrayList<EnvFrame>();
	}
	
	// repaint each frame
	public void repaint(){
		for (short i=0;i<frameList.size();i++){
			frameList.get(i).repaint();
		}
	}
	
	// save panels as jpeg images
	public void saveImage(String path){
		for (short i=0;i<frameList.size();i++){
			if (frameList.get(i).export()) frameList.get(i).saveImage(path+"/graph/", "graph"+i+"_");
		}
	}
	
	public int nbFrame(){
		return frameList.size();
	}
	
	public EnvFrame get(int i){
		return frameList.get(i);
	}
	
	public void addFrame(EnvFrame frame){
		frameList.add(frame);
	}
}
